package myai;
/**
 * Garnetのスピード対戦用AI
 * 敵にぶたれてもいいから波動拳うちまくる。波動拳の射程と攻撃力で瞬殺
 * @author Eita Aoki
 */
import java.util.LinkedList;

import enumerate.Action;
import enumerate.State;
import myutil.My;
import struct.CharacterData;
import struct.FrameData;
import struct.GameData;
import struct.MotionData;
public class GarnetSpeedAI extends MyAI{


	public GarnetSpeedAI(GameData arg0, boolean player){
		super(arg0,player);
		System.out.println("GarnetSpeedAI");

	}
	  //使いたいActionの全量
	  @Override
	  void setRootActions(){
		  if(my.getState()!=State.AIR){
			  myacs=My.actionGroundNonEnergy;

		  }else{
			  myacs=My.actionAirNonEnergy;
		  }


	  }


	//	  Node getRootNode(FrameData simFrameData){
	//			return new NodeSpeed(165 * 100000-(System.nanoTime()-start),simFrameData, null, myActionsEnoughEnergy, oppActionsEnoughEnergy, gd, player,
	//					  cc);
	//		}
	@Override
	void setHittingMyAction(){

		bestscore=-9999;
		bestac=null;
		HittingMyActions.clear();
		for(Action ac:myacs){
			double hpscore;
			FrameData nonActionFrame=calc.nonActionFrame;
			FrameData actedFrame=calc.getFrame(ac, calc.NONACT);
			CharacterData nonMy=nonActionFrame.getCharacter(player);
			CharacterData actedMy=actedFrame.getCharacter(player);
			CharacterData nonOpp=nonActionFrame.getCharacter(!player);
			CharacterData actedOpp=actedFrame.getCharacter(!player);
			hpscore=nonOpp.getHp()-actedOpp.getHp();


			MotionData mo=myMotion.get(ac.ordinal());

			if(hpscore>0){
				HittingMyActions.add(ac);
				double turnscore=
						(double)hpscore
						+(mo.attackDownProp?30.0:0.0)
						-((double)mo.attackStartUp)*0.01
						-((double)mo.cancelAbleFrame)*0.0001;
				if(turnscore>bestscore){bestscore=turnscore;bestac=ac;}
			}
		}
	}

	@Override
	public String getDoAction(){

		Action tac=null;
//
//		if(calc.isEnoughEnergy(tac=Action.STAND_D_DF_FC, true)&&my.getState()!=State.AIR&&100<distance&&distance<300){
//			return tac.name();
//		}

		  if(my.getState()!=State.AIR){
			  if(100<distance&&distance<300)
				  if(calc.IsInHitArea(tac=Action.STAND_D_DF_FC)){return tac.name();}
		  }

		if(bestac!=null){
			LinkedList<Action> moveActs=calc.getEnoughEnergyActions(false,
					Action.NEUTRAL,
					Action.STAND_D_DF_FA,
					Action.STAND_D_DF_FB
					);

			LinkedList<Action> moveNEUTRAL=calc.getEnoughEnergyActions(false,
					Action.NEUTRAL
					);

			if(my.getState()!=State.AIR){


				if(calc.getMinHpScore(tac=Action.STAND_D_DF_FC,moveNEUTRAL)>0){//超波動拳
					return(tac).name();
				}


				if(calc.getMinHpScore(tac=Action.STAND_B,moveActs)>0){
					return(tac).name();
				}
				//				 if( calc.getMinHpScore(tac=Action.CROUCH_FB,moveActs)>0){
				//						return(tac).name();//sppedモードの時はないほうがいい
				//					}
				if(calc.getMinHpScore(tac=Action.STAND_D_DB_BA,moveActs)>0){
					return(tac).name();
				}

				//				else if(calc.getMinHpScore(tac=Action.STAND_D_DF_FC,moveActs)>0){
				//					return(tac).name();
				//				}
				//				if(calc.getMinHpScore(tac=Action.STAND_D_DB_BB,moveActs)>0){
				//					return(tac).name();
				//				}
				//				else if(calc.getMinHpScore(tac=Action.STAND_F_D_DFA,moveActs)>0){
				//					return(tac).name();
				//				}
				//				if(calc.getHpScore(tac=Action.STAND_B)>0){
				//					return(tac).name();
				//				}
				//				else if(calc.getHpScore(tac=Action.CROUCH_FB)>0){
				//					return(tac).name();//sppedモードの時はないほうがいい
				//				}
				//				else if(calc.getHpScore(tac=Action.STAND_D_DF_FC)>0){
				//					return(tac).name();
				//				}
				//				else if(calc.getHpScore(tac=Action.STAND_D_DB_BB)>0){
				//					return(tac).name();
				//				}
				//				else if(calc.getHpScore(tac=Action.STAND_F_D_DFA)>0){
				//					return(tac).name();
				//				}
				if(calc.getMinHpScore(bestac,moveActs)>0){
					return(bestac).name();
				}

				//return(bestac);
				return mctsprocessing(simFrameData,HittingMyActions).name();



			}else{
				if(calc.getMinHpScore(tac=Action.AIR_UB,moveActs)>0){
					/*
					 * はいプロ 世界一ハメ技が得意 ハメ技界のtourist
					 * フェアプレー時代の終焉を告げる技 実質勝ち ハメ技するために生まれてきた技
					 */
					return(tac).name();
				}
				//					return(bestac);
				return mctsprocessing(simFrameData,HittingMyActions).name();

			}
		}else{

			if(my.getState()!=State.AIR){

				LinkedList<Action> moveActs=
						(distance<300)?
								calc.getEnoughEnergyActions(true,
										Action.FOR_JUMP,
										Action.FORWARD_WALK,
										Action.JUMP,
										Action.BACK_JUMP,
										Action.BACK_STEP
										):
											calc.getEnoughEnergyActions(true,
													Action.FORWARD_WALK,
													Action.FOR_JUMP,
													Action.JUMP,
													Action.BACK_JUMP,
													Action.BACK_STEP
													);

								return(calc.getMinMaxIfHadouken(moveActs).name());




			}else{
				return Action.AIR_GUARD.name();
			}
		}


	}


}
