package myutil;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;

import enumerate.Action;
import struct.MotionData;

public class MyLog implements Serializable{
	public Shoritu shos[];
	public int n;

	public MyLog(){
		n=0;
		shos=new Shoritu[enumerate.Action.values().length];
		for(int i=0;i<shos.length;i++){
			shos[i]=new Shoritu(Action.values()[i]);

		}
	}

	public void save(String fname)throws IOException {
		n++;
		this.setMeanScore();
		FileOutputStream fos=new FileOutputStream(fname);
		ObjectOutputStream oos = new ObjectOutputStream(fos);
		oos.writeObject(this);
		oos.flush();
		oos.close();

	}
	public static MyLog  load(String fname) throws IOException, ClassNotFoundException {
		FileInputStream fis = new FileInputStream(fname);
        ObjectInputStream ois = new ObjectInputStream(fis);

        MyLog mylog = (MyLog) ois.readObject();

        ois.close();

        return mylog;

	}

	public void visit(Action action,double score){
		shos[action.ordinal()].visit(score);
	}

	public void print(){
		System.out.println("試行回数:"+n);
		for(Shoritu s:shos){
			System.out.println(s.action.name()+":\t"+s.n+"\t"+s.mean);
		}
	}

	public void setMeanScore(){
		for(Shoritu s:shos){
			s.setMeanScore();
		}
	}

	public void sort(){
		Arrays.sort(shos);
	}
	public void revsort(){
		Arrays.sort(shos,Comparator.reverseOrder());
	}

	public Action[] getStrongActions(Action[] baseactions,ArrayList<MotionData> motions){
		LinkedList<Shoritu> tmpactions=new LinkedList<Shoritu>();
		LinkedList<Action>retactions=new LinkedList<Action>();

		double threshold=0;

		for(Action ac:baseactions){
			if(motions.get(ac.ordinal()).getAttackHitDamage()==0){
				retactions.add(ac);
				double score=shos[ac.ordinal()].mean;
				if(score<threshold&&score>Shoritu.rinf)threshold=score;
			}
			else{
				tmpactions.add(	shos[ac.ordinal()]);
			}
		}
		Collections.sort(tmpactions,Comparator.reverseOrder());
		for(Shoritu ts:tmpactions){
			if(ts.mean>=threshold)
				retactions.add(ts.action);
		}


		return retactions.toArray(new Action[retactions.size()]);
	}

	public static void main(String args[]){
		System.out.println("test");
		String fname="test.ser";
		MyLog mlog=new MyLog();
		try {
			mlog=MyLog.load(fname);
		} catch (ClassNotFoundException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}


//		mlog.visit(Action.AIR_A, 10);
//		mlog.visit(Action.STAND_B, 150);
//		mlog.visit(Action.AIR_A, 40);
//		mlog.setMeanScore();
		mlog.visit(Action.STAND_A, -1);
		mlog.visit(Action.STAND_B, 10);
		mlog.visit(Action.STAND_FB, -10);

		mlog.setMeanScore();

		try {
			mlog.save(fname);
		} catch (IOException e) {
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}


		mlog.revsort();
		mlog.print();
	}

}


class Shoritu implements Serializable , Comparable{
	static final double rinf=-1000;
	int n;//訪れた回数
	double sum;//スコアの合計
	double mean;
	Action action;
	public Shoritu(Action action){
		n=0;sum=0;mean=0;this.action=action;
	}

	public void visit(double score){
		n++;
		sum+=score;
	}


	@Override
	public int compareTo(Object arg){
		Double d1=mean;
		Double d2=((Shoritu)arg).mean;
		return d1.compareTo(d2);
		//return (mean>((Shoritu)arg).mean)?1:(mean<((Shoritu)arg).mean)?-1:0;
	}

	public void setMeanScore(){
		if(n==0)mean= rinf;
		else mean= (sum/(double)n);
	}




}