
import java.util.Random;

import aiinterface.CommandCenter;
import enumerate.Action;
import simulator.Simulator;
import struct.FrameData;
import struct.GameData;
import struct.CharacterData;

public class Aggressive extends FSMState{
	
	Random rand;
	MCTS Amcts;
	
	public Aggressive(GameData gd, boolean playerNumber) {
		super(gd,playerNumber);
		
		rand = new Random();
		
		Action[] actionsAir = new Action[] {Action.JUMP, Action.FOR_JUMP};
		
		actionsToPerform = 
				new Action[] {Action.STAND_D_DB_BA, Action.DASH,
						Action.THROW_A, Action.THROW_B, Action.STAND_A, Action.STAND_B,
						Action.CROUCH_A, Action.CROUCH_B, Action.STAND_FA, Action.STAND_FB, Action.CROUCH_FA,
						Action.CROUCH_FB, Action.STAND_D_DF_FA, Action.STAND_D_DF_FB, Action.STAND_F_D_DFA,
						Action.STAND_F_D_DFB, Action.STAND_D_DB_BB};
		
		Amcts = new MCTS();
		Amcts.Initialize(gd, playerNumber, actionsAir, actionsToPerform, Action.STAND_D_DF_FC);
		
	}

	@Override
	void onEnter() {
		
		
	}

	@Override
	Action onUpdate(CharacterData mySelf , CharacterData enemy,Simulator sim, FrameData frameData, boolean playerNumber, GameData gameData, CommandCenter commandCenter) {
		
		return Amcts.subProcesing(sim, frameData, playerNumber, gameData, commandCenter);
		
		
	}

	@Override
	void onExit() {
		
		
	}
	
}
