package myai;

/**
 * Garnet?スピード対戦用AI
 * 敵???れ?も???ら波動拳?????る。波動拳?射程?攻撃力?瞬殺
 * @author Eita Aoki
 */
import java.util.LinkedList;

import enumerate.Action;
import enumerate.State;
import myutil.My;
import myutil.Node;
import myutil.NodeSpeed;
import struct.CharacterData;
import struct.FrameData;
import struct.GameData;
import struct.MotionData;

public class GarnetSpeedAI extends MyAI {

	public GarnetSpeedAI(GameData arg0, boolean player) {
		super(arg0, player);
		System.out.println("GarnetSpeedAI");

	}

	// 使???Action?全?
	void setRootActions() {
		this.actionGround = My.actionGround;
		this.actionAir = My.actionAir;

	}

	Node getRootNode(FrameData simFrameData) {
		return new NodeSpeed(165 * 100000 - (System.nanoTime() - start), simFrameData, null, myActionsEnoughEnergy,
				oppActionsEnoughEnergy, gd, player, cc);
	}

	@Override
	void setHittingMyAction() {

		bestscore = -9999;
		bestac = null;
		HittingMyActions.clear();
		for (Action ac : myacs) {
			double hpscore;
			FrameData nonActionFrame = calc.nonActionFrame;
			FrameData actedFrame = calc.getFrame(ac, calc.NONACT);
			CharacterData nonMy = nonActionFrame.getCharacter(player);
			CharacterData actedMy = actedFrame.getCharacter(player);
			CharacterData nonOpp = nonActionFrame.getCharacter(player);
			CharacterData actedOpp = actedFrame.getCharacter(player);
			hpscore = nonOpp.getHp() - actedOpp.getHp();

			MotionData mo = myMotion.get(ac.ordinal());

			if (hpscore > 0) {
				HittingMyActions.add(ac);
				double turnscore = (double) hpscore + (mo.isAttackDownProp() ? 30.0 : 0.0)
						- ((double) mo.attackStartUp) * 0.01 - ((double) mo.cancelAbleFrame) * 0.0001;
				if (turnscore > bestscore) {
					bestscore = turnscore;
					bestac = ac;
				}
			}
		}
	}

	@Override
	Action getPrepareAction() {
		Action tac = null;
		if (HittingMyActions.size() > 0) {
			if (my.getState() != State.AIR) {
				if (calc.getHpScore(tac = Action.CROUCH_B) > 0 || distance < 50) {// 下?り
																					// 10
					return (tac);

				}
				if (calc.getHpScore(tac = Action.STAND_D_DF_FA) > 0) {// 横波動拳 30
					return (tac);

				}
				if (calc.getHpScore(tac = Action.STAND_D_DF_FB) > 0) {// 上波動拳 30
					return (tac);

				}
				if (calc.getHpScore(tac = Action.STAND_D_DB_BA) > 0) {// AIR扱???メ準備技
																		// 10
					return (tac);
				}
			} else {
				if (calc.getHpScore(tac = Action.AIR_UB) > 0) {// 最強コンボ 20
					return (tac);

				}
			}

			return this.mctsprocessing(simFrameData, HittingMyActions);
		} else {
			LinkedList<Action> moveActs = (distance < 300
					&& !calc.getEnoughEnergyActions(false, Action.STAND_D_DF_FA, Action.STAND_D_DF_FB).isEmpty())
							? calc.getEnoughEnergyActions(true, Action.FOR_JUMP, Action.FORWARD_WALK, Action.JUMP,
									Action.BACK_JUMP, Action.BACK_STEP)
							: calc.getEnoughEnergyActions(true, Action.FORWARD_WALK, Action.FOR_JUMP, Action.JUMP,
									Action.BACK_JUMP, Action.BACK_STEP);

			return (calc.getMinMaxIfHadouken(moveActs));
		}
	}

}
